public class FourierTransform
{


	public static double[] performTransform(double[] data, int num_w)
	{
		// X(w) = sum( x(n) * e^(-jwn))
		Polar[] fourierpoints = new Polar[data.length];
		for (int i=0;i<data.length;i++)
		{
			fourierpoints[i] = new Polar(data[i], -1 * i);
		}

		double[] transform = new double[num_w];
		double w_step = (2.0 * Math.PI)/(double)num_w;
		double w = -1 * Math.PI;
		int lastindex = num_w-1;
//System.out.print("start");
		for (int i=0;i<=num_w/2;i++)
		{
			double real = 0.0;
			double imag = 0.0;
			for (int j=0;j<fourierpoints.length;j++)
			{
				Polar p = fourierpoints[j];
				double angle = p.theta * w;
				real += p.radius * Math.cos(angle);
				imag += p.radius * Math.sin(angle);
//System.out.print("["+real+","+imag+","+angle+","+i+"]");
			}
//System.out.print(".");
			w += w_step;
			transform[i] = Math.sqrt(real*real + imag*imag);
//System.out.print(transform[i]);
			transform[lastindex] = transform[i];
			lastindex--;
		}
//System.out.println("end");
		return transform;
	}
}