import java.util.*;

public class Polynomial
{
	Vector terms;

	public Polynomial()
	{
		terms = new Vector();
	}

	public void add(SimplePolyTerm spt)
	{
		boolean found = false;
		for (int i=0;i<terms.size();i++)
		{
			SimplePolyTerm term = (SimplePolyTerm)terms.elementAt(i);
			if (term.getPower() == spt.getPower())
			{
				found = true;
				term.add(spt);
			}
		}
		if (!found)
			terms.addElement(spt.clone());
	}

	public Polynomial multiply(Polynomial poly)
	{
		Polynomial newPoly = new Polynomial();
		for (int i=0;i<terms.size();i++)
		{
			for (int j=0;j<poly.terms.size();j++)
			{
				SimplePolyTerm term1 = (SimplePolyTerm) terms.elementAt(i);
				SimplePolyTerm term2 = (SimplePolyTerm) poly.terms.elementAt(j);
				SimplePolyTerm spt = term1.multiply(term2);
				newPoly.add(spt);
			}
		}
		return newPoly;
	}

	public String toString()
	{
		String s = "";
		for (int i=0;i<terms.size();i++)
		{
			SimplePolyTerm spt = (SimplePolyTerm) terms.elementAt(i);
			if (i!=0)
			{
				s += " ";
			}
			s += spt.getCoefficient();
			s += "x^(";
			s += spt.getPower();
			s+=")";
		}
		return s;
	}

	public int getSize()
	{
		return terms.size();
	}

	public SimplePolyTerm getTerm(int i)
	{
		return (SimplePolyTerm)terms.elementAt(i);
	}
}